open Pycaml;;
open Unix;;
open Str;;
open String;;

let _py_float_product =
  python_pre_interfaced_function
    ~doc:"Compute the Product of two floatingpoint numbers in OCaml"
    [|FloatType;FloatType|]
    (fun py_args ->
       let x = pyfloat_asdouble py_args.(0)
       and y = pyfloat_asdouble py_args.(1)
       in pyfloat_fromdouble ( x*.y))
in
let _py_foo =
  python_pre_interfaced_function
    ~doc:"just a silly test"
    [|StringType|]
    (fun py_args ->
       let x = pystring_asstring py_args.(0)
       in pystring_fromstring (concat "" ("j'ai recu:" :: x ::[])))
in
  register_pre_functions_for_python
    [|("floatproduct", _py_float_product);("py_foo",_py_foo) |]
;;

Printf.printf "yeah\n%!";;

python();; 



